/* G-CTB GNU Contabilidad
 * Copyright (C) 2001 Branly Abendano, EPN Ingenieria Sistemas  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public  
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "CtaContable.h"

Gda_Recordset *GetListadoTotalDeCtasContables (void)
{
   Gda_Recordset *grs;
   gint rc;
                                        
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
				"SELECT C.CD_CTA_CONTABLE AS CODIGO, C.NM_CTA_CONTABLE AS NOMBRE, C.DESCRIPCION AS DESCRIPCION, T.NM_TIPO_CTA_CONTABLE AS TIPO, C.TOTAL AS TOTAL, C.CTA_SUPERIOR AS CTA_SUPERIOR,  C.NIVEL AS NIVEL FROM CTA_CONTABLE C, TIPO_CTA_CONTABLE T WHERE T.CD_TIPO_CTA_CONTABLE=C.CD_TIPO_CTA_CONTABLE ORDER BY CD_CTA_CONTABLE",
                              	GDA_OPEN_STATIC,
                              	GDA_LOCK_PESSIMISTIC,
                              	0);
  	if (rc < 0) {
    		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	}

 	return GDA_RECORDSET(grs); 
}

Gda_Recordset *GetListadoTotalDeCtasContablesTransacciones (void)
{
   Gda_Recordset *grs;
   gint rc;
                                        
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
				"SELECT T.CD_CTA_CONTABLE, C.NM_CTA_CONTABLE FROM TRANSACCION_CONTABLE T, CTA_CONTABLE C WHERE C.CD_CTA_CONTABLE=T.CD_CTA_CONTABLE GROUP BY T.CD_CTA_CONTABLE, C.NM_CTA_CONTABLE ORDER BY T.CD_CTA_CONTABLE",
                              	GDA_OPEN_STATIC,
                              	GDA_LOCK_PESSIMISTIC,
                              	0);
  	if (rc < 0) {
    		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	}

  	return GDA_RECORDSET(grs); 
}

Gda_Recordset *GetListadoNombresDeCtasContables (void)
{
   Gda_Recordset *grs;
   gint rc;
                                        
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
				"SELECT C.NM_CTA_CONTABLE FROM CTA_CONTABLE C WHERE C.TOTAL='N' ORDER BY C.CD_CTA_CONTABLE",
                              	GDA_OPEN_STATIC,
                              	GDA_LOCK_PESSIMISTIC,
                              	0);
  	if (rc < 0) {
    		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	}

	return GDA_RECORDSET(grs); 
}

Gda_Recordset *GetRegistroDeCtaContable (gchar *CodigoCtaContable)
{
   Gda_Recordset *grs;
   gchar *ConsultaInicial = "SELECT CD_CTA_CONTABLE,NM_CTA_CONTABLE,DESCRIPCION,CD_TIPO_CTA_CONTABLE,TOTAL,CTA_SUPERIOR,NIVEL FROM CTA_CONTABLE WHERE CD_CTA_CONTABLE='";
   gchar *ConsultaTmp = NULL;
   gint rc;

   	ConsultaTmp = g_strconcat(ConsultaInicial,CodigoCtaContable,NULL);
   	ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);

   	grs = gda_recordset_new();
   	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
   	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
				ConsultaTmp,
                              	GDA_OPEN_STATIC,
                              	GDA_LOCK_PESSIMISTIC,
                              	0);
   	if (rc < 0) {
    		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	}

  	return GDA_RECORDSET(grs); 
}

gint InsertNuevoCtaContable (gchar *CodigoCtaContable, gchar *NombreCtaContable, 
			     gchar *DescripcionCtaContable, gchar *CodigoTipoCtaContable,
			     gchar *TotalCtaContable, gchar *NivelCtaContable, gchar *CtaContableSuperior)
{
   gchar *ConsultaInicial = "INSERT INTO CTA_CONTABLE(CD_CTA_CONTABLE,NM_CTA_CONTABLE,DESCRIPCION,CD_TIPO_CTA_CONTABLE,TOTAL,CTA_SUPERIOR,NIVEL) VALUES('";
   gchar *ConsultaTmp = NULL;
        
   Gda_Recordset *grs;
   Gda_Command* cmd;
   gulong* n;
        
        ConsultaTmp = g_strconcat(ConsultaInicial,CodigoCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,NombreCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,DescripcionCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"',",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CodigoTipoCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,",'",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,TotalCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CtaContableSuperior,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"',",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,NivelCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,")",NULL);

        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);

        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);

	return 0;
}

gint DeleteCtaContable (gchar *CodigoCtaContable)
{
   gulong* n;
   gchar *ConsultaInicial = "DELETE FROM CTA_CONTABLE WHERE CD_CTA_CONTABLE='";
   gchar *ConsultaTmp = NULL;

   Gda_Recordset *grs;
   Gda_Command* cmd;
 
        ConsultaTmp = g_strconcat(ConsultaInicial,CodigoCtaContable,NULL);
	ConsultaTmp = g_strconcat(ConsultaTmp,"'"); 

        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
 
        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);
   
	return 0;

}

char* ConsultarCodigoTipoCtaContable(gchar* NombreTipo)
{                                                 
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT CD_TIPO_CTA_CONTABLE FROM TIPO_CTA_CONTABLE WHERE NM_TIPO_CTA_CONTABLE='";
   gchar *ConsultaTmp = NULL;
   gchar *CodigoTipoCtaContable = NULL;
   Gda_Field *field;
        
        ConsultaTmp = g_strconcat(ConsultaInicial,NombreTipo,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);
 
        grs = gda_recordset_new();      
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);
                                                  
        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 0);
   
        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");
   
        CodigoTipoCtaContable = (gchar *)gda_stringify_value(CodigoTipoCtaContable, 0, field);
   
        return CodigoTipoCtaContable;        
}

