/* G-CTB GNU Contabilidad
 * Copyright (C) 2001 Branly Abendano, EPN Ingenieria Sistemas  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public  
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "CtaContableTmp.h"

Gda_Recordset *GetListadoTotalDeCtasContablesTmp (gfloat CodigoTransaccion) 
{
   gchar *ConsultaInicial = "SELECT * FROM CTA_CONTABLE_TMP WHERE TRANSACCION=";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;
   Gda_Recordset *grs;
   gint rc;

  	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);

  	ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
                                        
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                              ConsultaTmp,
                              GDA_OPEN_STATIC,
                              GDA_LOCK_PESSIMISTIC,
                              0);
  	if (rc < 0) {
    		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	}

  	return GDA_RECORDSET(grs); 
}

Gda_Recordset *GetListadoTotalDeCtasContablesTmp_CtasTotales (gfloat CodigoTransaccion)
{
   gchar *ConsultaInicial = "SELECT * FROM CTA_CONTABLE_TMP WHERE TOTAL='S' AND TRANSACCION=";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;
   Gda_Recordset *grs;
   gint rc;

  	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);

  	ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
                                        
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                              ConsultaTmp,
                              GDA_OPEN_STATIC,
                              GDA_LOCK_PESSIMISTIC,
                              0);
  	if (rc < 0) {
		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	}

  	return GDA_RECORDSET(grs); 
}

gint ConsultarVerificarExisteCtaContableInsertada_CtaTotales(gchar *CodigoCtaContable, gfloat CodigoTransaccion)  
{
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT * FROM CTA_CONTABLE_TMP WHERE TOTAL='S' AND TRANSACCION=";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;
   gint i=0;
   Gda_Field *field;
        
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);

        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp," AND CD_CTA_CONTABLE='",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CodigoCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);
 
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);
        gda_recordset_move_next (grs);
        
        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 1);

        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");
        
        while (!gda_recordset_eof(grs)) {
                i++;
                gda_recordset_move_next(grs);
        }
   
        return i;
}



gint InsertCtasContablesTMP_DeAcuerdoAPeriodoTransContable_N_S (gfloat CodigoTransaccion,gchar *FechaInicio, gchar *FechaFinal)
{
   gchar *ConsultaInicial = "INSERT INTO CTA_CONTABLE_TMP select cc2.cd_cta_contable, cc2.nm_cta_contable, cc2.descripcion, cc2.cd_tipo_cta_contable, cc2.total, cc2.cta_superior, cc2.nivel,";
   gchar *ConsultaIntermedia = " from cta_contable cc1 JOIN transaccion_contable tc ON  ((cc1.cd_cta_contable=tc.cd_cta_contable) AND (tc.FE_transaccion >='";
   gchar *ConsultaFinal = "')) JOIN cta_contable cc2 ON ((cc2.cd_cta_contable=cc1.cta_superior))
			    where cc1.cd_cta_contable like '%'  AND cc1.total = 'N' AND cc2.total = 'S' AND cc2.cd_cta_contable like '%'
			    group by cc2.cd_cta_contable, cc2.nm_cta_contable, cc2.descripcion, cc2.cd_tipo_cta_contable,  cc2.total,  cc2.cta_superior,  cc2.nivel";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;        
   Gda_Recordset *grs;
   Gda_Command* cmd;
   gulong* n=0;
    
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);
	
        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaIntermedia,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,FechaInicio,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"') AND (tc.FE_transaccion <= '",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,FechaFinal,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaFinal,NULL);
   
        g_print("ConsultaTmp: %s\n",ConsultaTmp);
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);

        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);

	return 0;
}

gint InsertCtasContablesTMP_DeAcuerdoAPeriodoTransContable_S (gfloat CodigoTransaccion,gchar *FechaInicio, gchar *FechaFinal)
{
   gchar *ConsultaInicial = "INSERT INTO CTA_CONTABLE_TMP select cc3.cd_cta_contable, cc3.nm_cta_contable, cc3.descripcion, cc3.cd_tipo_cta_contable,  cc3.total, cc3.cta_superior, cc3.nivel,";
   gchar *ConsultaIntermedia = " from cta_contable cc3 JOIN transaccion_contable tc1 ON ((cc3.cd_cta_contable=tc1.cd_cta_contable) AND (tc1.FE_transaccion >= '";
   gchar *ConsultaFinal = "')) where cc3.cd_cta_contable like '%'  AND  cc3.total = 'N' group by cc3.cd_cta_contable, cc3.nm_cta_contable, cc3.descripcion,
  			    cc3.cd_tipo_cta_contable, cc3.total, cc3.cta_superior, cc3.nivel";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;        
   Gda_Recordset *grs;
   Gda_Command* cmd;
   gulong* n=0;
    
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);
	
        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaIntermedia,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,FechaInicio,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"') AND (tc.FE_transaccion <= '",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,FechaFinal,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaFinal,NULL);
   
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);

        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);

	return 0;
}

gint InsertCtasContablesTMP_DeAcuerdoACierreTransCierre (gfloat CodigoTransaccion, gint CodigoCierre)
{
   gchar *ConsultaInicial = "INSERT INTO CTA_CONTABLE_TMP select tci.cd_cta_contable, cc.nm_cta_contable, cc.descripcion, cc.cd_tipo_cta_contable, cc.total, cc.cta_superior, cc.nivel,";
   gchar *ConsultaIntermedia = " from trans_cierre tci JOIN cta_contable_tmp cct ON ((tci.cd_cta_contable<>cct.cd_cta_contable) and (tci.cd_cierre =";
   gchar *ConsultaFinal = ")) where tci.cd_cta_contable like '%' group by tci.cd_cta_contable, cc.nm_cta_contable, cc.descripcion, cc.cd_tipo_cta_contable,
  			   cc.total, cc.cta_superior, cc.nivel";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;        
   gchar *CadenaCodigoCierre = NULL;
   Gda_Recordset *grs;
   Gda_Command* cmd;
   gulong* n=0;
    
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);
	sprintf (CadenaCodigoCierre,"%d",CodigoCierre);
	
        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaIntermedia,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CadenaCodigoCierre,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,") AND (cct.transaccion =",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,")) JOIN cta_contable cc ON ((cc.cd_cta_contable=tci.cd_cta_contable) and (tci.cd_cierre = ",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CadenaCodigoCierre,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaFinal,NULL);
   
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);

        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);

	return 0;
}

gint InsertCtasContablesTMP_DeAcuerdoACierreTransContIntermedio (gfloat CodigoTransaccion,gchar *FechaInicio, gchar *FechaFinal)
{
   gchar *ConsultaInicial = "INSERT INTO CTA_CONTABLE_TMP select cc2.cd_cta_contable, cc2.nm_cta_contable, cc2.descripcion, cc2.cd_tipo_cta_contable, cc2.total, cc2.cta_superior, cc2.nivel,";
   gchar *ConsultaIntermedia = " from cta_contable cc1 JOIN transaccion_contable tc ON ((cc1.cd_cta_contable=tc.cd_cta_contable) AND (tc.FE_transaccion >='";
   gchar *ConsultaFinal = " )) where  cc1.cd_cta_contable like '%' AND cc1.total = 'N' AND cc2.total = 'S' AND cc2.cd_cta_contable like '%'
			   group by cc2.cd_cta_contable, cc2.nm_cta_contable, cc2.descripcion, cc2.cd_tipo_cta_contable, cc2.total,
  			   cc2.cta_superior, cc2.nivel";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;        
   Gda_Recordset *grs;
   Gda_Command* cmd;
   gulong* n=0;
    
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);
	
        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaIntermedia,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,FechaInicio,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"') AND (tc.FE_transaccion <= '",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,FechaFinal,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaFinal,NULL);
   
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);

        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);

	return 0;
}

gint InsertCtasContablesTMP_DeAcuerdoACierreTransContIntermedio_N (gfloat CodigoTransaccion,gchar *FechaInicio, gchar *FechaFinal)
{
   gchar *ConsultaInicial = "INSERT INTO CTA_CONTABLE_TMP select cc3.cd_cta_contable, cc3.nm_cta_contable, cc3.descripcion, cc3.cd_tipo_cta_contable, cc3.total, cc3.cta_superior, cc3.nivel, ";
   gchar *ConsultaIntermedia = " from cta_contable cc3 JOIN transaccion_contable tc1 ON ((cc3.cd_cta_contable=tc1.cd_cta_contable) and (tc1.FE_transaccion > '";
   gchar *ConsultaFinal = "')) where cc3.cd_cta_contable like '%' AND cc3.total = 'N' group by cc3.cd_cta_contable, cc3.nm_cta_contable, cc3.descripcion, cc3.cd_tipo_cta_contable, cc3.total, cc3.cta_superior, cc3.nivel";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;        
   Gda_Recordset *grs;
   Gda_Command* cmd;
   gulong* n=0;
    
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);
	
        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaIntermedia,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,FechaInicio,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"') AND (tc.FE_transaccion < '",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,FechaFinal,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaFinal,NULL);
   
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);

        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);

	return 0;
}



Gda_Recordset *GetListadoCtasContablesTMP_DeAcuerdoACierreTransCierre (gfloat CodigoTransaccion, gint CodigoCierre)
{
   gchar *ConsultaInicial = "select tci.cd_cta_contable, cc.nm_cta_contable, cc.descripcion, cc.cd_tipo_cta_contable, cc.total, cc.cta_superior, cc.nivel,";
   gchar *ConsultaIntermedia = " from trans_cierre tci JOIN cta_contable_tmp cct ON ((tci.cd_cta_contable<>cct.cd_cta_contable) and (tci.cd_cierre =";
   gchar *ConsultaFinal = ")) where tci.cd_cta_contable like '%' group by tci.cd_cta_contable, cc.nm_cta_contable, cc.descripcion, cc.cd_tipo_cta_contable,
  			   cc.total, cc.cta_superior, cc.nivel";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;        
   gchar *CadenaCodigoCierre = NULL;        
   Gda_Recordset *grs;
   gint rc;
    
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);
	sprintf (CadenaCodigoCierre,"%d",CodigoCierre);
	
        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaIntermedia,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CadenaCodigoCierre,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,") AND (cct.transaccion =",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,")) JOIN cta_contable cc ON ((cc.cd_cta_contable=tci.cd_cta_contable) and (tci.cd_cierre = ",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CadenaCodigoCierre,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,ConsultaFinal,NULL);
   
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                              		ConsultaTmp,
                              		GDA_OPEN_STATIC,
                              		GDA_LOCK_PESSIMISTIC,
                              		0);
  	if (rc < 0) {
    		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	} 
  
  	return GDA_RECORDSET(grs);
}

Gda_Recordset *GetListadoCtasContablesTMPDeUnNivel (gfloat CodigoTransaccion, gint Nivel)
{
   gchar *ConsultaInicial = "SELECT cd_cta_contable, nm_cta_contable, descripcion, cd_tipo_cta_contable, total, cta_superior,nivel FROM CTA_CONTABLE_TMP WHERE TOTAL='S' AND TRANSACCION=";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;        
   gchar *CadenaNivel = NULL;
   Gda_Recordset *grs;
   gint rc;
    
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);
	sprintf (CadenaNivel,"%d",Nivel);
	
        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp," AND NIVEL=",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CadenaNivel,NULL);
   
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                              		ConsultaTmp,
                              		GDA_OPEN_STATIC,
                              		GDA_LOCK_PESSIMISTIC,
                              		0);
  	if (rc < 0) {
    		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	} 
  
  	return GDA_RECORDSET(grs);
}

gint ConsultarVerificarExisteCtaContableTmpInsertada(gchar *CodigoCtaContable, gfloat CodigoTransaccion)  
{
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT * FROM CTA_CONTABLE_TMP WHERE TRANSACCION=";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;
   gint i=0;
   Gda_Field *field;
        
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);

        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp," AND CD_CTA_CONTABLE='",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CodigoCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);
 
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);
        
        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 1);

        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");
        
        while (!gda_recordset_eof(grs)) {
                i++;
                gda_recordset_move_next(grs);
        }
   
        return i;
}

gint ConsultarNivelMaximoCtaContableTmp(gfloat CodigoTransaccion)  
{
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT MAX(NIVEL) FROM CTA_CONTABLE_TMP WHERE TRANSACCION=";
   gchar *ConsultaTmp = NULL;
   gchar *CadenaCodigoTransaccion = NULL;
   gint Nivel=0;
   gchar *CadenaNivel=NULL;
   Gda_Field *field;
        
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);

        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoTransaccion,NULL);
 
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);
        
	field = gda_recordset_field_idx (GDA_RECORDSET(grs), 0);
        CadenaNivel = (gchar *)gda_stringify_value(CadenaNivel, 0, field);
   
	sscanf(CadenaNivel,"%d",&Nivel);

        return Nivel;
}



gint InsertNuevoCtaContableTmp (gchar *CodigoCtaContable, gchar *NombreCtaContable,
                             gchar *DescripcionCtaContable, gchar *CodigoTipoCtaContable,
                             gchar *TotalCtaContable, gchar *NivelCtaContable, gchar *CtaContableSuperior,gfloat CodigoTransaccion)
{
   gchar *ConsultaInicial = "INSERT INTO CTA_CONTABLE_TMP(CD_CTA_CONTABLE,NM_CTA_CONTABLE,DESCRIPCION,CD_TIPO_CTA_CONTABLE,TOTAL,CTA_SUPERIOR,NIVEL,TRANSACCION) VALUES('";
   gchar *ConsultaTmp = NULL;
                                
   Gda_Recordset *grs;
   Gda_Command* cmd;
   gchar *CadenaCodigoTransaccion = NULL;
   gulong* n=0;
   
	sprintf (CadenaCodigoTransaccion,"%f",CodigoTransaccion);

        ConsultaTmp = g_strconcat(ConsultaInicial,CodigoCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,NombreCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,DescripcionCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"',",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CodigoTipoCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,",'",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,TotalCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CtaContableSuperior,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"',",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,NivelCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,",",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CadenaCodigoTransaccion,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,")",NULL);

        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);

        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);

        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);
        
        return 0;
}



